'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
var React = require('react');
var classnames = require('classnames');
var utilsCommons = require('@highlight-ui/utils-commons');
var typography = require('@highlight-ui/typography');
function _interopDefaultLegacy(e) {
  return e && typeof e === 'object' && 'default' in e ? e : {
    'default': e
  };
}
var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classnames__default = /*#__PURE__*/_interopDefaultLegacy(classnames);

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function () {
  __assign = Object.assign || function __assign(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
function __rest(s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
}
var styles$1 = {
  "tabItemContainer": "TabItem-module__ih8jxZf7__v2-1-24",
  "selected": "TabItem-module__ICs6-Mz1__v2-1-24",
  "disabled": "TabItem-module__iuE8fx-3__v2-1-24"
};
function TabItemWithRef(_a, ref) {
  var _b, _c, _d;
  var children = _a.children,
    className = _a.className,
    _e = _a.disabled,
    disabled = _e === void 0 ? false : _e,
    _f = _a.focus,
    focus = _f === void 0 ? false : _f,
    onChange = _a.onChange,
    _g = _a.selected,
    selected = _g === void 0 ? false : _g,
    name = _a.name,
    metadata = _a.metadata,
    remainingProps = __rest(_a, ["children", "className", "disabled", "focus", "onChange", "selected", "name", "metadata"]);
  var containerClassName = classnames__default["default"](styles$1.tabItemContainer, (_b = {}, _b[styles$1.selected] = selected, _b), (_c = {}, _c[styles$1.disabled] = disabled, _c), (_d = {}, _d[styles$1.focus] = focus, _d), className);
  var handleChange = function () {
    return onChange && onChange(name);
  };
  return React__default["default"].createElement(typography.Typography, __assign({
    token: "body-base",
    component: "span",
    onClick: disabled ? undefined : handleChange,
    className: containerClassName,
    ref: ref,
    tabIndex: disabled ? -1 : 0,
    role: "tab",
    "aria-selected": selected
  }, utilsCommons.parseMetadata(metadata), remainingProps), children);
}
TabItemWithRef.displayName = 'TabItem';
var TabItem = React__default["default"].forwardRef(TabItemWithRef);
var styles = {
  "tabContainer": "Tab-module__Xw6iR-I7__v2-1-24",
  "disabled": "Tab-module__O7Ph3dN6__v2-1-24",
  "alignLeft": "Tab-module__-PX8mN4D__v2-1-24",
  "alignCenter": "Tab-module__vOJlQuUR__v2-1-24",
  "alignRight": "Tab-module__NJ2xdhGh__v2-1-24"
};
var Tab = function (_a) {
  var _b;
  var _c = _a.disabled,
    disabled = _c === void 0 ? false : _c,
    _d = _a.value,
    value = _d === void 0 ? '' : _d,
    onChange = _a.onChange,
    _e = _a.className,
    className = _e === void 0 ? '' : _e,
    _f = _a.placement,
    placement = _f === void 0 ? 'center' : _f,
    children = _a.children,
    metadata = _a.metadata,
    remainingProps = __rest(_a, ["disabled", "value", "onChange", "className", "placement", "children", "metadata"]);
  return React__default["default"].createElement("div", __assign({}, remainingProps, utilsCommons.parseMetadata(metadata), {
    role: "tablist",
    "aria-orientation": "horizontal",
    "aria-label": "Tabs",
    className: classnames__default["default"](styles.tabContainer, (_b = {}, _b[styles.disabled] = disabled, _b[styles.alignLeft] = placement === 'left', _b[styles.alignCenter] = placement === 'center', _b[styles.alignRight] = placement === 'right', _b), className)
  }), React__default["default"].Children.map(children, function (tab) {
    var isTabItem = React__default["default"].isValidElement(tab) && tab.type === TabItem;
    utilsCommons.invariant(isTabItem, "Tab only accepts TabItem as children");
    if (!isTabItem) {
      return null;
    }
    var name = tab.props.name;
    return React__default["default"].cloneElement(tab, {
      selected: value === name,
      onChange: disabled ? undefined : onChange,
      metadata: utilsCommons.suffixMetadata(metadata, "item-" + name)
    });
  }));
};
exports.Tab = Tab;
exports.TabItem = TabItem;
//# sourceMappingURL=index.js.map
